#!perl

#  Command format:
#
print "perl netconnect2008.pl <input file> <prefix file> <template file> <suffix file> <output file>\n";
#
#  input file contains a list of server names
#  template file contains the report configuration template with $server variables embedded
#  output file is where the resultant report configuration text will be written


$input_file = shift @ARGV;

print "Input file ...... $input_file\n";

$prefix_file = shift @ARGV;

print "Prefix file is ...... $prefix_file\n";


$template_file = shift @ARGV;

print "Template file is ...... $template_file\n";

$suffix_file = shift @ARGV;

print "Suffix file is ...... $suffix_file\n";

$output_file = shift @ARGV;

print "Output file is ...... $output_file\n";

open (targets, "< $input_file") or die "Couldn't open input file $input_file\n";

open (prefix, "< $prefix_file") or die "Couldn't open prefix file $prefix_file\n";

open (template, "< $template_file") or die "Couldn't open template file $template_file\n";

open (suffix, "< $suffix_file") or die "Couldn't open suffix file $suffix_file\n";

@targets = <targets>;
@prefix = <prefix>;
@suffix = <suffix>;
@templates = <template>; # Read the whole template file in to an array

open (output, "> $output_file") or die "Couldn't open output file $output_file\n";

    foreach $prefix (@prefix) {
       print output $prefix;
    }

$prev_ip = "";

foreach $target (@targets) {

    chomp($target);
	($ip,$name,$comm) = split(/,/,$target); # split out the individual data items from the complete line
    print "Next target is ...... $ip\n";
	
    @save_templates = @templates; # We need to save this for the next server
	if ($ip eq $prev_ip) {
		print "Duplicate IP address ... .$ip\n";

	}
	else {
		$prev_ip = $ip;
    		foreach $template (@templates) {
      			$template =~ s/\$n/$name/;# Replace the $n in the template with device name from input file
			$template =~ s/\$i/$ip/; # Replace the $i in the template with device ip address from input file
      			print output $template;
    		}
	}
    @templates = @save_templates; # Put it back for the next one
}

    foreach $suffix (@suffix) {
       print output $suffix;
    }